VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cDlgs"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'======================================================================================================

' >> Descripcin    ::  Mdulo con funciones para cuadros de dilogo ( Abrir carpeta y propiedades de archivo )
  
'======================================================================================================


Private Const WM_USER = &H400
Private Const BFFM_SETSELECTIONA As Long = (WM_USER + 102)
Private Const BFFM_SETSELECTIONW As Long = (WM_USER + 103)
Private Const LPTR = (&H0 Or &H40)

Private Const SEE_MASK_INVOKEIDLIST = &HC
Private Const SEE_MASK_NOCLOSEPROCESS = &H40
Private Const SEE_MASK_FLAG_NO_UI = &H400
Private Type SHELLEXECUTEINFO
    cbSize As Long
    fMask As Long
    hWnd As Long
    lpVerb As String
    lpFile As String
    lpParameters As String
    lpDirectory As String
    nShow As Long
    hInstApp As Long
    lpIDList As Long
    lpClass As String
    hkeyClass As Long
    dwHotKey As Long
    hIcon As Long
    hProcess As Long
End Type

Private Type CLSIdType
  id(16) As Byte
End Type

'para SHBrowseForFolder
Private Type BROWSEINFOTYPE
    hOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpFn As Long
    lParam As Long
    iImage As Long
End Type

' Dilogo seleccin de carpeta de win ...
Private Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBROWSEINFOTYPE As BROWSEINFOTYPE) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal pv As Long)
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal dwLength As Long)
Private Declare Function LocalAlloc Lib "kernel32" (ByVal uFlags As Long, ByVal uBytes As Long) As Long
Private Declare Function LocalFree Lib "kernel32" (ByVal hMem As Long) As Long

' Para obtener informacin del archivo
Private Declare Function ShellExecuteEX Lib "shell32.dll" Alias "ShellExecuteEx" (SEI As SHELLEXECUTEINFO) As Long



' \\ Dilogo  - Propiedades de archivo
' ----------------------------------------------------------------------------------------
Function showDlgFileProperty(sFileName As String, Hwnd_Form As Long) As Long
    Dim SEI As SHELLEXECUTEINFO
    Dim ret As Long
    
    If Len(sFileName) = 0 Then Exit Function
    
    With SEI
        .cbSize = Len(SEI)
        .fMask = SEE_MASK_NOCLOSEPROCESS Or SEE_MASK_INVOKEIDLIST Or SEE_MASK_FLAG_NO_UI
        .hWnd = Hwnd_Form
        .lpVerb = "properties"
        .lpFile = sFileName
        .lpParameters = vbNullChar
        .lpDirectory = vbNullChar
        .nShow = 0
        .hInstApp = 0
        .lpIDList = 0
        
        ret = ShellExecuteEX(SEI)
        showDlgFileProperty = .hInstApp
    End With
End Function


' \\ Dilogo  - buscar carpeta
' ----------------------------------------------------------------------------------------
Public Function showDialog( _
    frmOwner As Form, _
    Optional ByVal sPath As String = "", _
    Optional sTitle As String = "", _
    Optional ShowNewFolder As Boolean = True) As String

Dim BIT As BROWSEINFOTYPE
Dim itemID As Long
Dim selectedPathPointer As Long
Dim tmpPath As String * 256
    
    If Len(sPath) > 0 Then
        If Not Right$(sPath, 1) <> "\" Then
            sPath = Left$(sPath, Len(sPath) - 1)
        End If
    End If
    
    With BIT
        .hOwner = frmOwner.hWnd
        
        If ShowNewFolder Then .ulFlags = 64
        
        .lpszTitle = sTitle
        selectedPathPointer = LocalAlloc(LPTR, Len(sPath) + 1)
        CopyMemory ByVal selectedPathPointer, ByVal sPath, Len(sPath) + 1
        .lParam = selectedPathPointer
    End With
    
    itemID = SHBrowseForFolder(BIT)
    If itemID Then
        If SHGetPathFromIDList(itemID, tmpPath) Then
            
            sPath = Left$(tmpPath, InStr(tmpPath, vbNullChar) - 1)
            If Len(sPath) Then
                If Right(sPath, 1) <> "\" Then sPath = sPath & "\"
                showDialog = sPath
            End If
            
        End If
        Call CoTaskMemFree(itemID)
    End If
    Call LocalFree(selectedPathPointer)
End Function



